# The LearningOnline Network
# Replication Manager
# (Access Handler for File Transfers
# (lonacc: Cookie Based Access Handler
# 5/21/99,5/22,5/29,5/31,6/15 Gerd Kortemeyer)
# 6/16,6/18 Gerd Kortemeyer)
# 6/18,6/21,6/26,6/28,6/29,6/30,
# 7/2,7/3,7/9,7/10,7/12,
# 01/06,01/14,10/5 Gerd Kortemeyer

package Apache::lonrep;

use strict;
use Apache::Constants qw(:common :http);
use Apache::lonnet();
use Apache::File();
use CGI::Cookie();

sub handler {
    my $r = shift;
    if (-e $r->finfo) {
      return OK;
    } else {
      my $filename=$r->filename.$r->path_info;
      if (-e "$filename.in.transfer") {
	sleep 10;
        $r->filename($filename);
        if (-e $r->finfo) {
	   return OK;
        } else {
	   $r->log_reason("Waiting for file transfer timed out",$filename);
	   return HTTP_SERVICE_UNAVAILABLE;
        }
      } else {
          my $response=Apache::lonnet::repcopy($filename);
          if ($response==OK) {
	      $r->filename($filename);
              return OK;
          }
          my %cookies=CGI::Cookie->parse($r->header_in('Cookie'));
          my $lonid=$cookies{'lonID'};
          if ($lonid) {
	     $r->log_reason('Replication failed for '.$lonid->value);
             return $response;
	  } else {
	     $r->log_reason('Replication failed for unknown user'); 
             return FORBIDDEN;
          } 
      }
    }
}

1;
__END__








