# The LearningOnline Network with CAPA
# User Roles Screen
# (Directory Indexer
# (Login Screen
# 5/21/99,5/22,5/25,5/26,5/31,6/2,6/10,7/12,7/14 Gerd Kortemeyer)
# 11/23 Gerd Kortemeyer)
# 1/14,03/06,06/01,07/22,07/24,07/25,
# 09/04,09/06,09/28,09/29,09/30,10/2,10/5,10/26,10/28 Gerd Kortemeyer
#
package Apache::lonroles;

use strict;
use Apache::lonnet();
use Apache::lonuserstate();
use Apache::Constants qw(:common);
use Apache::File();

sub handler {

    my $r = shift;

    my $now=time;
    my $then=$ENV{'user.login.time'};
    my $envkey;


# ================================================================== Roles Init

    if ($ENV{'form.selectrole'}) {
       &Apache::lonnet::appenv("request.course.id"  => '',
                               "request.course.fn"  => '',
                               "request.course.uri" => '',
                               "request.course.sec" => '',
                               "request.role" => 'cm'); 
        foreach $envkey (keys %ENV) {
         if ($envkey=~/^user\.role\./) {
	    my ($dum1,$dum2,$role,@pwhere)=split(/\./,$envkey);
            my $where=join('.',@pwhere);
            my $trolecode=$role.'.'.$where;
            if ($ENV{'form.'.$trolecode}) {
               my ($tstart,$tend)=split(/\./,$ENV{$envkey});
               my $tstatus='is';
               if ($tstart) {
      		  if ($tstart>$then) { 
                     $tstatus='future';
                  }
               }
               if ($tend) {
                  if ($tend<$then) { $tstatus='expired'; }
                  if ($tend>$now) { $tstatus='will_not'; }
               }
               if ($tstatus eq 'is') {
                   $where=~s/^\///;
                   my ($cdom,$cnum,$csec)=split(/\//,$where);
                   &Apache::lonnet::appenv('request.role' => $trolecode,
                                           'request.course.sec' => $csec);
                   if ($cnum) {
		      &Apache::lonuserstate::readmap($cdom.'/'.$cnum);
                      if ($ENV{'form.orgurl'}) {
                         $r->internal_redirect($ENV{'form.orgurl'});
                         return OK;
		      }
                   }
               }
            } 
	  }
        }
    }
        

# =============================================================== No Roles Init

    $r->content_type('text/html');
    $r->send_http_header;
    return OK if $r->header_only;

    $r->print(<<ENDHEADER);
<html>
<head>
<title>LON-CAPA User Roles</title>
</head><body bgcolor="#FFFFFF">
ENDHEADER

# ------------------------------------------ Get Error Message from Environment

    my ($fn,$priv,$nochoose,$error,$msg)=split(/:/,$ENV{'user.error.msg'});
    if ($ENV{'user.error.msg'}) {
       $r->log_reason(
     "$msg for $ENV{'user.name'} domain $ENV{'user.domain'} access $priv",$fn);
    }

# ---------------------------------------------------------------- Who is this?

    my $advanced=0;
    foreach $envkey (keys %ENV) {
        if ($envkey=~/^user\.role\./) {
	    my ($dum1,$dum2,$role,@pwhere)=split(/\./,$envkey);
            if ($role ne 'st') { $advanced=1; }
        }
    }

# -------------------------------------------------------- Generate Page Output
# --------------------------------------------------------------- Error Header?
    if ($error) {
	$r->print("<h1>LON-CAPA Access Control</h1>");
        $r->print("<hr><pre>Access  : ".
                  Apache::lonnet::plaintext($priv)."\n");
        $r->print("Resource: $fn\n");
        $r->print("Action  : $msg\n</pre><hr>");
    } else {
        $r->print("<h1>LON-CAPA User Roles</h1>");
    }
# -------------------------------------------------------- Choice or no choice?
    if ($nochoose) {
        if ($advanced) {
	   $r->print("<h2>Assigned User Roles</h2>\n");
        } else {
           $r->print("<h2>Sorry ...</h2>\nThis resource might be part of");
           if ($ENV{'request.course.id'}) {
	       $r->print(' another');
           } else {
               $r->print(' a certain');
           } 
           $r->print(' course.</body></html>');
           return OK;
        } 
    } else {
        if ($advanced) {
           $r->print("<h2>Select a User Role</h2>\n");
        } else {
	   $r->print("<h2>Enter a Course</h2>\n");
        }
        $r->print('<form method=post action="'.(($fn)?$fn:$r->uri).'">');
        $r->print('<input type=hidden name=orgurl value="'.$fn.'">');
        $r->print('<input type=hidden name=selectrole value=1>');
    }
# ----------------------------------------------------------------------- Table
    $r->print('<table><tr>');
    unless ($nochoose) { $r->print('<th>&nbsp;</th>'); }
    if ($advanced) {
       $r->print('<th>User Role</th><th colspan=2>Extent</th>'.
                 '<th>Start</th><th>End</th><th>Remark</th></tr>'."\n");
    } else {
	$r->print('<th>Course</th></tr>'."\n");
    }

    foreach $envkey (sort keys %ENV) {
        if ($envkey=~/^user\.role\./) {
	    my ($dum1,$dum2,$role,@pwhere)=split(/\./,$envkey);
            my $where=join('.',@pwhere);
            my $trolecode=$role.'.'.$where;
            my ($tstart,$tend)=split(/\./,$ENV{$envkey});
            my $tremark='';
            my $tstatus='is';
            my $tpstart='&nbsp;';
            my $tpend='&nbsp;';
            if ($tstart) {
		if ($tstart>$then) { 
                   $tstatus='future';
                   if ($tstart<$now) { $tstatus='will'; }
                }
                $tpstart=localtime($tstart);
            }
            if ($tend) {
                if ($tend<$then) { $tstatus='expired'; }
                if ($tend>$now) { $tstatus='will_not'; }
                $tpend=localtime($tend);
            }
            if ($ENV{'request.role'} eq $trolecode) {
		$tstatus='selected';
            }
            my $tbg;
            if ($tstatus eq 'is') {
		$tbg='#77FF77';
            } elsif ($tstatus eq 'future') {
                $tbg='#FFFF77';
            } elsif ($tstatus eq 'will') {
                $tbg='#FFAA77';
                $tremark.='Active at next login. ';
            } elsif ($tstatus eq 'expired') {
                $tbg='#FF7777';
	    } elsif ($tstatus eq 'will_not') {
                $tbg='#AAFF77';
                $tremark.='Expired after logout. ';
            } elsif ($tstatus eq 'selected') {
                $tbg='#33FF33';
                $tremark.='Currently selected. ';
            }
            my $trole;
            if ($role =~ /^cr\//) {
	       my ($rdummy,$rdomain,$rauthor,$rrole)=split(/\//,$role);
               $tremark.='<br>Defined by '.$rauthor.' at '.$rdomain.'.';
               $trole=$rrole;
	    } else {
               $trole=Apache::lonnet::plaintext($role);
            }
            my $ttype;
            my $twhere;
            my ($tdom,$trest,$tsection)=
               split(/\//,Apache::lonnet::declutter($where));
            if ($trest) {
		$ttype='Course';
                if ($tsection) {
                   $ttype.='<br>Section/Group: '.$tsection;
                }     
                my $tcourseid=$tdom.'_'.$trest;
                if ($ENV{'course.'.$tcourseid.'.description'}) {
		    $twhere=$ENV{'course.'.$tcourseid.'.description'};
                } else {
                    my %newhash=Apache::lonnet::coursedescription($tcourseid);
                    if (%newhash) {
			$twhere=$newhash{'description'};
                    } else {
                        $twhere='Currently not available';
                        $ENV{'course.'.$tcourseid.'.description'}=$twhere;
                    }
                }
            } elsif ($tdom) {
                $ttype='Domain';
                $twhere=$tdom;
            } else {
                $ttype='System';
                $twhere='system wide';
            }
               
            $r->print('<tr bgcolor='.$tbg.'>');
            unless ($nochoose) {
		if ($tstatus eq 'is') {
                    $r->print('<td><input type=submit value=Select name="'.
                              $trolecode.'"></td>');
                } else {
                    $r->print('<td>&nbsp;</td>');
                }
            }
            $r->print('<td>'.$trole.'</td><td>'.
		      $ttype.'</td><td>'.$twhere.'</td><td>'.$tpstart.
                      '</td><td>'.$tpend.
                      '</td><td>'.$tremark.'&nbsp;</td></tr>'."\n");
        }
    }
    my $tremark='';
    if ($ENV{'request.role'} eq 'cm') {
	$r->print('<tr bgcolor="#33FF33">');
        $tremark='Currently selected.';
    } else {
        $r->print('<tr bgcolor="#77FF77">');
    }
    unless ($nochoose) {
       if ($ENV{'request.role'} ne 'cm') {
          $r->print('<td><input type=submit value=Select name="cm"></td>');
       } else {
          $r->print('<td>&nbsp;</td>');
       }
    }
    $r->print('<td colspan=5>No role specified'.
                      '</td><td>'.$tremark.'&nbsp;</td></tr>'."\n");

    $r->print('</table>');
    unless ($nochoose) {
	$r->print("</form>\n");
    }
# ------------------------------------------------------------ Priviledges Info
  if ($advanced) {
    $r->print('<hr><h2>Current Priviledges</h2>');

    foreach $envkey (sort keys %ENV) {
        if ($envkey=~/^user\.priv\.$ENV{'request.role'}\./) {
            my $where=$envkey;
            $where=~s/^user\.priv\.$ENV{'request.role'}\.//;
            my $ttype;
            my $twhere;
            my ($tdom,$trest,$tsec)=
               split(/\//,Apache::lonnet::declutter($where));
            if ($trest) {
		$ttype='Course';
                $twhere=$ENV{'course.'.$tdom.'_'.$trest.'.description'};
                if ($tsec) {
		    $twhere.=' (Section/Group: '.$tsec.')';
                }
            } elsif ($tdom) {
                $ttype='Domain';
                $twhere=$tdom;
            } else {
                $ttype='System';
                $twhere='/';
            }
            $r->print("\n<h3>".$ttype.': '.$twhere.'</h3><ul>');
            map {
              if ($_) {
		  my ($prv,$restr)=split(/\&/,$_);
                  my $trestr='';
                  if ($restr ne 'F') {
                      my $i;
                      $trestr.=' (';
                      for ($i=0;$i<length($restr);$i++) {
		         $trestr.=
                           Apache::lonnet::plaintext(substr($restr,$i,1));
                         if ($i<length($restr)-1) { $trestr.=', '; }
		      }
                      $trestr.=')';
                  }
                  $r->print('<li>'.Apache::lonnet::plaintext($prv).$trestr.
                            '</li>');
	      }
            } sort split(/:/,$ENV{$envkey});
            $r->print('</ul>');
        }
    }
  }
# -------------------------------------------------------------- Debug - remove

    $->print("<hr><h1>Debugging</h1><hr>\n");
    
    foreach $envkey (sort keys %ENV) {
	$r->print("$envkey ---- $ENV{$envkey}<br>");
    }

# ------------------------------------------------------------------- End Debug

    $r->print("</body></html>\n");
    return OK;
} 

1;
__END__
