# The LearningOnline Network with CAPA
# TeX Conversion Module
#
# 05/29/00,05/30,10/11,10/20 Gerd Kortemeyer

package Apache::lontexconvert;

use strict;
use tth;
use vars qw($errorstring);
use Apache::lonmsg;

# ====================================================================== Header

sub header {
  $errorstring='';
  if ($ENV{'browser.mathml'}) {
      &tth::ttminit();
      return '<?xml version="1.0"?>'
            .'<?xml-stylesheet type="text/css" href="/adm/MathML/mathml.css"?>'
            .'<!DOCTYPE html SYSTEM "/adm/MathML/mathml.dtd" '
            .'[<!ENTITY mathns "http://www.w3.org/1998/Math/MathML">]>'
            .'<html xmlns:math="http://www.w3.org/1998/Math/MathML" ' 
            .'xmlns="http://www.w3.org/TR/REC-html40">'
            ."\n";
  } else {
      &tth::tthinit();
      my $headerstring='<html>';
      if ($ENV{'browser.os'} eq 'mac') { 
         $headerstring.="<head>\n"
             .'<meta Content-Type="text/html; charset=x-mac-roman">'
	     ."\n</head>\n";
      }
      return $headerstring."\n";
  }
}

# ================================================================== Conversion

sub converted {
    my $texstring=shift;
    my $xmlstring;
    if ($ENV{'browser.mathml'}) {
      $xmlstring=&tth::ttm($$texstring);
      $xmlstring=~s/\<math\>/\<math xmlns=\"\&mathns\;\"\>/g;
      $xmlstring=~s/\<br\>/\<br\/\>/g;
      $xmlstring=~s/\<p\>/\<p\>\<\/p\>/g;
      $errorstring.=&tth::ttmerror();
  } else {
      $xmlstring=&tth::tth($$texstring);
      $errorstring.=&tth::ttherror();
  }
  return $xmlstring;
}

# ====================================================================== Footer

sub footer {
  my $xmlstring='';
  if ($ENV{'request.state'} eq 'construct') {
      $xmlstring.='<address>'.$errorstring.'</address>';
  } else {
      &Apache::lonmsg::author_res_msg($ENV{'request.filename'},$errorstring);
  }
# -------------------------------------------------------------------- End Body
  $xmlstring.='</html>';
  return $xmlstring;
}

1;
__END__







