# The LearningOnline Network with CAPA # <script> definiton

package Apache::structuretags; 

use strict;
use Apache::lonnet;

sub BEGIN {
  &Apache::lonxml::register('Apache::structuretags',('block','while','randomlist','problem','outtext','web','tex'));
}

sub start_outtext {
}

sub end_outtext {
}

sub start_web {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $bodytext=&Apache::lonxml::get_all_text("/web",$$parser[$#$parser]);
  return $bodytext;
}

sub end_web {
}

sub start_tex {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $bodytext=&Apache::lonxml::get_all_text("/tex",$$parser[$#$parser]);
  return '';
}

sub end_tex {
}

sub start_problem {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $args ='';
  if ( $#$parstack > -1 ) {
    $args=$$parstack[$#$parstack];
  }
  my $name = &Apache::run::run("{$args;".'return $name}',$safeeval);
  return "<title>$name</title>\n<body bgcolor=#FFFFFF>\n"
}

sub end_problem {
  return "</body>\n";
}

sub start_block {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;

  my $code = @$parstack[$#$parstack];
  $code =~ s/\"//g;
  $code .=';return $condition;';
#  print "<br>$code<br>";
  my $result = &Apache::run::run($code,$safeeval);
  if ( ! $result ) { 
#    my $skip=$$parser[$#$parser]->get_text("/block");
    my $skip=&Apache::lonxml::get_all_text("/block",$$parser[$#$parser]);
#    print "skipped $skip";
  }
  return "";
}

sub end_block {
}

sub start_while {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;

  my $code = @$parstack[$#$parstack];
  $code =~ s/\"//g;
  $code .=';return $condition;';

  push( @Apache::structuretags::whileconds, $code); 
  my $result = &Apache::run::run($code,$safeeval);
  my $bodytext=$$parser[$#$parser]->get_text("/while");
  push( @Apache::structuretags::whilebody, $bodytext);
  if ( $result ) { 
    &Apache::lonxml::newparser($parser,\$bodytext);
  }
  return "";
}

sub end_while {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $code = pop @Apache::structuretags::whileconds;
  my $bodytext = pop @Apache::structuretags::whilebody;
  my $result = &Apache::run::run($code,$safeeval);
  if ( $result ) { 
    &Apache::lonxml::newparser($parser,\$bodytext);
  } 
  return "";
}

# <randomlist> 
#  <tag1>..</tag1>
#  <tag2>..</tag2>
#  <tag3>..</tag3>
#  ... 
# </randomlist>
sub start_randomlist {
  my ($target,$token,$parstack,$parser,$safeeval)=@_;
  my $body= &Apache::lonxml::get_all_text("/randomlist",$$parser[$#$parser]);
  my $b_parser= HTML::TokeParser->new(\$body);
  my $b_tok;
  my @randomlist;
  my $list_item;

  while($b_tok = $b_parser->get_token() ) {
    if($b_tok->[0] eq 'S') { # start tag
    # get content of the tag until matching end tag
    # get all text upto the matching tag
    # and push the content into @randomlist
      $list_item = &Apache::lonxml::get_all_text('/'.$b_tok->[1],$b_parser);
      $list_item = "$b_tok->[4]"."$list_item"."</$b_tok->[1]>";
      push(@randomlist,$list_item);
   #  print "<BR><B>START-TAG $b_tok->[1], $b_tok->[4], $list_item</B>";
    }
    if($b_tok->[0] eq 'T') { # text
    # what to do with text in between tags?
      #  print "<B>TEXT $b_tok->[1]</B><BR>";
    }
    # if($b_tok->[0] eq 'E') { # end tag, should not happen
      #  print "<B>END-TAG $b_tok->[1]</B><BR>";
    # }
  }
  my @idx_arr = (0 .. $#randomlist);
  &Apache::structuretags::shuffle(\@idx_arr);
  my $bodytext = '';
  for(0 .. $#randomlist) {
    $bodytext .= "$randomlist[ $idx_arr[$_] ]";
  }

  &Apache::lonxml::newparser($parser,\$bodytext);
  return "";
}

sub shuffle {
    my $a=shift;
    my $i;
    for($i=@$a;--$i;) {
      my $j=int rand($i+1);
      next if $i == $j;
      @$a[$i,$j] = @$a[$j,$i];
    }
}

sub end_randomlist {
}


1;
__END__
